unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, jpeg,
  GdiPlus, GdiPlusHelpers, // Using Erik van Bilsen's Delphi GDI+ library
  gtCstPDFEng, gtExPDFEng, gtPDFEng, gtClasses3, gtCstDocEng, gtCstPlnEng,
  Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    EFrom: TEdit;
    Label1: TLabel;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    ETo: TEdit;
    Button3: TButton;
    OpenDialog2: TOpenDialog;
    PB: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  TIFFImage: IGPImage;
  PageGuid: TGUID;
  JPEGImage1: TJPEGImage;
  PageCount, I: Integer;
  PageDimensions: TGPSizeF;
  gtPDFEngine1: TgtPDFEngine;

begin
  if (EFrom.Text = '') or (ETo.Text = '') then exit;
  try
    PB.Visible := true;

    // Quelldatei laden
    TIFFImage := TGPBitmap.FromFile(EFrom.Text);

    // Anzahl der Frames ermitteln
    PageGuid := FrameDimensionPage;
    PageCount := TIFFImage.GetFrameCount(PageGuid);

    if PageCount > 0  then begin
      PB.Max := PageCount;

      // PDF-Engine erzeugen
      gtPDFEngine1 := TgtPDFEngine.Create(nil);
      gtPDFEngine1.FileName := ETo.Text;
      gtPDFEngine1.MeasurementUnit := muPixels;
      gtPDFEngine1.Preferences.ShowSetupDialog := False;
      gtPDFEngine1.Page.PaperSize := Custom;
      gtPDFEngine1.Preferences.ProcessAfterEachPage := true;

      gtPDFEngine1.BeginDoc; // Dokument erstellen

      for i := 0 to PageCount - 1 do begin
        // Frame auswhlen
        TIFFImage.SelectActiveFrame(PageGuid, i);

        // Mae des aktuellen Frames ermitteln ...
        TIFFImage.GetPhysicalDimension(PageDimensions);

        // ... und der aktuellen PDF-Seite zuweisen
        gtPDFEngine1.Page.Width := PageDimensions.Width;
        gtPDFEngine1.Page.Height := PageDimensions.Height;

        if i <> 0 then
          gtPDFEngine1.NewPage; // Eine neue Seite erstellen

        // Aktuellen Frame in eine temporre JPEG-Datei speichern
        TIFFImage.Save('temp_frame.jpg', TGPImageFormat.Jpeg);

        // Temporre Datei laden ...
        JPEGImage1 := TJPEGImage.Create;
        JPEGImage1.LoadFromFile('temp_frame.jpg');

        // ... und auf die aktuelle Seite der PDF-Datei zeichnen
        gtPDFEngine1.DrawImage(0,0, JPEGImage1);

        PB.StepIt();
      end;

      // PDF-Datei speichern
      gtPDFEngine1.EndDoc;
    end;

  except
    on E: Exception do
      ShowMessage(E.ClassName + ': ' + E.Message);
  end;

  PB.Visible := false;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   OpenDialog1.Execute;
    EFrom.Text := OpenDialog1.FileName;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   OpenDialog2.Execute;
    ETo.Text := OpenDialog2.FileName;
end;

end.
